"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var containerDecorators_1 = require("./utils/containerDecorators");
var DickBottModule_1 = require("../modules/DickBottModule");
var DickBottEngine = /** @class */ (function () {
    function DickBottEngine(container, registryRetriever) {
        if (container === void 0) { container = containerDecorators_1.DefaultContainer; }
        if (registryRetriever === void 0) { registryRetriever = defaultRegistryRetriever; }
        this.container = container;
        this.modules = [];
        this.registerModule(new DickBottModule_1.DickBottModule());
        this.intentRegistry = registryRetriever(this.container);
    }
    DickBottEngine.prototype.registerModule = function (module) {
        if (module.modules) {
            module.modules(this.container);
        }
        if (module.register) {
            module.register(this.intentRegistry);
        }
        this.modules.push(module);
        return true;
    };
    DickBottEngine.prototype.getService = function (serviceIdentifier) {
        return this.container.get(serviceIdentifier);
    };
    DickBottEngine.prototype.registerIntent = function (intent) {
        this.intentRegistry.add(intent);
        return this;
    };
    return DickBottEngine;
}());
exports.DickBottEngine = DickBottEngine;
;
function defaultRegistryRetriever(container) {
    return container.get("IIntentRegistry");
}
exports.defaultRegistryRetriever = defaultRegistryRetriever;
//# sourceMappingURL=DickBottEngine.js.map