"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var IntentDecorator_1 = require("./IntentDecorator");
var IntentRegistry = /** @class */ (function () {
    function IntentRegistry(container) {
        this.container = container;
    }
    IntentRegistry.prototype.add = function (intent) {
        var metadata = IntentDecorator_1.IntentMetadataExtractor.extract(intent);
        if (this.has(metadata.name)) {
            throw new Error("An intent is already registered with name: " + name);
        }
        this.container.bind("Intent")
            .to(intent)
            .inSingletonScope()
            .whenTargetNamed(metadata.name);
        return this;
    };
    IntentRegistry.prototype.has = function (name) {
        return this.container.isBoundNamed("Intent", name);
    };
    IntentRegistry.prototype.get = function (name) {
        if (!this.has(name)) {
            throw new Error("No intent registered with name: " + name);
        }
        return this.container.getNamed("Intent", name);
    };
    IntentRegistry.prototype.getAll = function () {
        return this.container.getAll("Intent");
    };
    IntentRegistry = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject("Container")),
        __metadata("design:paramtypes", [Object])
    ], IntentRegistry);
    return IntentRegistry;
}());
exports.IntentRegistry = IntentRegistry;
//# sourceMappingURL=IntentRegistry.js.map